/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package i18n;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import static java.lang.System.exit;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import javax.swing.JToolBar;
import javax.swing.SortOrder;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellEditor;
import net.miginfocom.swing.MigLayout;
import org.apache.commons.lang.StringEscapeUtils;
import org.jdesktop.swingx.JXTable;

/**
 *
 * @author favdb
 */
public class I18NDlg extends JDialog implements ActionListener {

	public static String VERSION = "01";

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		try {
			javax.swing.UIManager.LookAndFeelInfo[] installedLookAndFeels = javax.swing.UIManager.getInstalledLookAndFeels();
			for (int idx = 0; idx < installedLookAndFeels.length; idx++) {
				if ("Nimbus".equals(installedLookAndFeels[idx].getName())) {
					javax.swing.UIManager.setLookAndFeel(installedLookAndFeels[idx].getClassName());
					break;
				}
			}
		} catch (ClassNotFoundException
				| InstantiationException
				| IllegalAccessException
				| javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(I18NDlg.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}
		java.awt.EventQueue.invokeLater(() -> {
			JFrame frame = new JFrame();
			frame.setTitle("I18N");
			frame.setVisible(true);
			I18NDlg dlg = new I18NDlg(frame);
			dlg.setVisible(true);
			frame.dispose();
		});
	}

	private JComboBox cbLanguage;
	private List<String> languages;
	private boolean modified;
	private JButton btSave;
	private JTextArea txComment;
	private JTextPane infoPane1;
	private JXTable table;
	private JTextArea text;
	private DefaultTableModel tableModel;
	private String curLanguage;
	private File initFile;
	private boolean bModified;
	private String initDir;
	private Properties propMsg;
	private File savedFile;

	public I18NDlg(JFrame frame) {
		super(frame);
		initAll();
	}

	private void initAll() {
		init();
		intUi();
	}

	private void init() {
		File f = IOTools.selectFile(this,
				"messages",
				"properties",
				"Properties file (*.properties)");
		if (f == null) {
			exit(0);
		}
		initFile = f;
		initDir = f.getAbsolutePath();
		I18N.initMsgFile(initFile.getAbsolutePath());
		this.setModalityType(ModalityType.DOCUMENT_MODAL);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	}

	@SuppressWarnings("unchecked")
	private void intUi() {
		setLayout(new MigLayout("wrap 9"));
		setTitle("UI Translation - version " + VERSION);
		this.setIconImage(IconUtil.getImageIcon("/icons/icon").getImage());

		JToolBar bar = new JToolBar();
		bar.setLayout(new MigLayout());
		bar.setRollover(false);
		bar.setFloatable(false);

		bar.add(new JLabel("Language : "));
		cbLanguage = new JComboBox<>();
		DefaultComboBoxModel<String> model = new DefaultComboBoxModel<>();
		model.addElement("Select a language");
		languages = new ArrayList<>();
		for (Language.LANGUAGE lang : Language.LANGUAGE.values()) {
			model.addElement(lang.name() + " " + lang.getI18N());
			languages.add(lang.name());
		}
		cbLanguage.setModel(model);
		cbLanguage.addItemListener((ItemEvent evt) -> {
			if (evt.getStateChange() == ItemEvent.SELECTED) {
				ChangeLanguage();
			}
		});
		bar.add(cbLanguage);

		JButton btNew = initButton("", "file-new", "Create a new File");
		btNew.addActionListener((ActionEvent evt) -> {
			btNewAction();
		});
		bar.add(btNew);

		JButton btOpen = initButton("", "file-open", "Open a file");
		btOpen.addActionListener((ActionEvent evt) -> {
			btOpenAction();
		});
		bar.add(btOpen);

		JButton btRefresh = initButton("", "refresh", "Ignore changes and reset");
		btRefresh.addActionListener((ActionEvent evt) -> {
			modified = false;
			ChangeLanguage();
		});
		bar.add(btRefresh);

		btSave = initButton("", "file-save", "Save the file");
		btSave.addActionListener((ActionEvent evt) -> {
			save();
		});
		bar.add(btSave);

		JButton btExit = initButton("", "file-exit", "Exit");
		btExit.setName("btExit");
		btExit.addActionListener((ActionEvent evt) -> {
			onExit();
		});
		bar.add(btExit);
		add(bar, "growx,wrap");

		add(new JLabel("Comment"), "wrap");
		txComment = new javax.swing.JTextArea();
		txComment.setEditable(true);
		txComment.setColumns(25);
		txComment.setRows(5);
		txComment.addKeyListener(new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent evt) {
				modified = true;
			}
		});
		JScrollPane scrollComment = new JScrollPane();
		scrollComment.setViewportView(txComment);
		add(scrollComment, "sg, span, split 2, grow");

		infoPane1 = new JTextPane();
		infoPane1.setEditable(false);
		infoPane1.setText("{0}, {1}, ... are for insertion of variables data, they are mandatory.\n\n\\n stands for line feed.");
		JScrollPane scrollInfo = new JScrollPane();
		scrollInfo.setViewportView(infoPane1);
		scrollInfo.setFocusable(false);
		add(scrollInfo, "grow,wrap");

		table = new JXTable();
		initTable();
		JScrollPane scrollTable = new JScrollPane();
		scrollTable.setViewportView(table);
		add(scrollTable, "span,growx");

		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				//System.out.println("mouseClicked(e=" + e.toString() + ")");
				SelectRow();
			}

			@Override
			public void mouseReleased(MouseEvent e) {
				//System.out.println("mouseReleased(e=" + e.toString() + ")");
				if (e.getButton() == 3) {
					showPopup(e);
				}
			}

			private void showPopup(MouseEvent e) {
				//System.out.println("showPopup(e=" + e.toString() + ")");
				if (!(e.getButton() == 3)) {
					return;
				}
				int row = table.rowAtPoint(e.getPoint());
				int column = table.columnAtPoint(e.getPoint());
				if (!table.isRowSelected(row)) {
					table.changeSelection(row, column, false, false);
				}
				JPopupMenu popup = createPopupMenu();
				popup.show(e.getComponent(), e.getX(), e.getY());
			}
		});

		add(new JLabel("Text : "), "span");
		text = new JTextArea();
		text.setColumns(20);
		text.setRows(5);
		text.setEditable(false);
		text.addCaretListener((javax.swing.event.CaretEvent evt) -> {
			textCaretUpdate(evt);
		});
		JScrollPane scrollInfoText = new JScrollPane();
		scrollInfoText.setViewportView(text);
		add(scrollInfoText, "span, growx");

		pack();
		setLocationRelativeTo(null);
		//setModal(true);
		this.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				if (modified) {
					int confirmed = JOptionPane.showConfirmDialog(null,
							"Modified data not saved. Are you sure you want to exit?",
							"Confirm",
							JOptionPane.YES_NO_OPTION);
					if (confirmed == JOptionPane.YES_OPTION) {
						dispose();
					}
				} else {
					dispose();
				}
				exit(0);
			}
		});
	}

	public JPopupMenu createPopupMenu() {
		JPopupMenu menu = new JPopupMenu();
		//JLabel lbTitle = new JLabel("Copy default message");
		//menu.add(lbTitle);
		JMenuItem menuItem = new JMenuItem();
		menuItem.setName("Copy");
		menuItem.setText("Copy");
		menuItem.addActionListener(this);
		menu.add(menuItem);
		menuItem = new JMenuItem();
		menuItem.setName("Past");
		menuItem.setText("Past");
		menuItem.addActionListener(this);
		String str=TextClipboard.getClipboardContents();
		if (str.isEmpty() || !str.startsWith("i18n:")) {
			menuItem.setEnabled(false);
		}
		menu.add(menuItem);
		return (menu);
	}

	public static JButton initButton(String text, String icon, String tips) {
		JButton bt = new JButton();
		if (!text.isEmpty()) {
			bt.setText(text);
		}
		if (!icon.isEmpty()) {
			bt.setIcon(IconUtil.getIcon(icon));
		}
		if (!tips.isEmpty()) {
			bt.setToolTipText(tips);
		}
		bt.setFocusable(false);
		bt.setMargin(new Insets(0, 0, 0, 0));
		return (bt);
	}

	@SuppressWarnings("unchecked")
	private void btNewAction() {
		I18NnewDlg dlg = new I18NnewDlg(this, languages);
		dlg.setVisible(true);
		String str = dlg.getLanguage();
		if (str.isEmpty()) {
			return;
		}
		cbLanguage.addItem(str);
		cbLanguage.setSelectedItem(str);
		ChangeLanguage();
	}

	@SuppressWarnings("unchecked")
	private void btOpenAction() {
		File f = IOTools.selectFile(this,
				"",
				"properties",
				"Properties file (*.properties)");
		if (f == null) {
			return;
		}
		curLanguage = "file:" + f.getAbsolutePath();
		cbLanguage.addItem(curLanguage);
		cbLanguage.setSelectedItem(curLanguage);
		ChangeLanguage();
	}

	private void textCaretUpdate(javax.swing.event.CaretEvent evt) {
		String str = text.getText().replace("\n", "\\n");
		int row = table.getSelectedRow();
		if (row != -1) {
			table.setValueAt(str, row, 2);
			modified = true;
		}
	}

	private void initTable() {
		List<String> cols = new ArrayList<>();
		cols.add("Key");
		cols.add("Default");
		cols.add(" ");
		tableModel = new DefaultTableModel(cols.toArray(), 0) {
			@Override
			public boolean isCellEditable(int row, int column) {
				if (column == 2) {
					return (true);
				}
				return (false);
			}
		};
		// read all keys
		InputStream stream;
		try {
			stream = new FileInputStream(initFile);
			BufferedReader txt = new BufferedReader(new InputStreamReader(stream));
			String line;
			try {
				line = txt.readLine();
				while (line != null) {
					if (!line.isEmpty() && !(line.startsWith("#") || line.startsWith(" ")) && line.contains("=")) {
						String[] s = line.split("=");
						s[0] = s[0].trim();
						s[1] = s[1].trim();
						if (!s[0].startsWith("language.")) {
							tableModel.addRow(s);
						}
					}
					line = txt.readLine();
				}
				txt.close();
			} catch (IOException ex) {
				System.out.println(ex.getLocalizedMessage());
			}
		} catch (FileNotFoundException ex) {
			ex.printStackTrace(System.err);
			exit(0);
		}
		table.setModel(tableModel);
		table.setSortOrder(0, SortOrder.ASCENDING);
		CellEditorListener ChangeNotification = new CellEditorListener() {
			@Override
			public void editingCanceled(ChangeEvent e) {
			}

			@Override
			public void editingStopped(ChangeEvent e) {
				modified = true;
				int row = table.getSelectedRow();
				text.setText((String) table.getValueAt(row, 2));
			}

		};
		TableCellEditor z = table.getCellEditor();
		if (z == null) {
			//System.err.println("I18NDlg TableCellEditor is null");
			return;
		}
		z.addCellEditorListener(ChangeNotification);
	}

	private void ChangeLanguage() {
		if (cbLanguage.getSelectedIndex() == 0) {
			return;
		}
		if (tableModel.getRowCount() > 0) {
			for (int i = table.getRowCount() - 1; i > 0; i--) {
				tableModel.setValueAt("", i, 2);
			}
		}
		curLanguage = (String) cbLanguage.getSelectedItem();
		if (curLanguage.contains("=")) {
			return;
		}
		String bundler="";
		try {
			bundler = initDir.replace(".properties", "_") + curLanguage.substring(0, curLanguage.indexOf(" ")) + ".properties";
		} catch(java.lang.StringIndexOutOfBoundsException ex) {
			
		}
		File f = new File(bundler);
		if (!f.exists()) {
			bundler = initDir.replace(".properties", "_") + curLanguage.substring(0, 2) + ".properties";
		}
		StringBuilder m = new StringBuilder();
		m.append("Ressource file for ").append(curLanguage).append("\n");
		m.append("(").append(bundler).append(")\n");
		System.out.println(m.toString());
		propMsg = new Properties();
		try {
			try (FileInputStream input = new FileInputStream(bundler)) {
				propMsg.load(input);
			}
		} catch (IOException ex) {
			System.err.println("messages file error ");
		}
		setLanguageHeader();
		bModified = false;
		for (int i = 0; i < tableModel.getRowCount(); i++) {
			String s1 = (String) tableModel.getValueAt(i, 0);
			String s2 = "";
			try {
				String x = propMsg.getProperty(s1);
				s2 = ((String) x).replace("\n", "\\n");
			} catch (Exception e) {
			}
			if (s2.equals("")) {
				continue;
			}
			tableModel.setValueAt(s2.trim(), i, 2);
		}
		readComment(curLanguage.substring(0, 2).toLowerCase());
		SelectRow();
		text.setText("");
		text.setEditable(true);
	}

	private void SelectRow() {
		int row = table.getSelectedRow();
		if (row == -1) {
			return;
		}
		int col = 2;
		if (table.getValueAt(row, col) != null) {
			String str = ((String) table.getValueAt(row, col)).replace("\\n", "\n");
			text.setEditable(true);
			text.setText(str);
			text.setCaretPosition(0);
		}
	}

	private void save() {
		//select a valid file name, if the file exists override
		if (txComment.getText().isEmpty()) {
			JOptionPane.showMessageDialog(this,
					"The \"Comment\" field is empty, please fill it with your name.\nSaving is aborted.",
					"Warning",
					JOptionPane.ERROR_MESSAGE);
			return;
		}
		File dir = new File(new File(System.getProperty("user.home")).getAbsolutePath()
				+ File.separator + "messages_"
				+ curLanguage.substring(0, 2).toLowerCase() + ".properties");
		if (savedFile == null || savedFile.equals(dir)) {
			dir = IOTools.selectFile(this, dir.getAbsolutePath(), ".properties", ".properties file");
			if (dir.getAbsolutePath().equals(initDir)) {
				JOptionPane.showMessageDialog(null,
						"Unable to save language file to original file",
						"Error",
						JOptionPane.ERROR_MESSAGE);
				return;
			}
		}
		savedFile = dir;
		try {
			try (Writer out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(dir), "UTF-8"))) {
				out.write("#" + txComment.getText().replace("\n", "\n#") + "\n");
				out.write("#Date: " + new java.util.Date() + "\n");
				for (int i = 0; i < table.getRowCount(); i++) {
					String val = (String) table.getValueAt(i, 2);
					if (val != null && !val.isEmpty()) {
						val = StringEscapeUtils.escapeJava(val);
						out.write((String) table.getValueAt(i, 0) + "=" + val + "\n");
					}
				}
				out.flush();
			}
			modified = false;
		} catch (FileNotFoundException ex) {
			System.err.println(ex.getLocalizedMessage());
		} catch (IOException ex) {
			ex.printStackTrace(System.err);
		}
	}

	private void readComment(String lang) {
		String fileName = initDir.replace(".properties", "_" + lang + ".properties");
		InputStream stream = null;
		if (curLanguage.startsWith("file:")) {
			try {
				stream = new FileInputStream(curLanguage.replace("file:", ""));
			} catch (FileNotFoundException ex) {
				ex.printStackTrace(System.err);
				return;
			}
		} else {
			try {
				stream = new FileInputStream(fileName);
			} catch (FileNotFoundException ex) {
			}
		}
		if (stream == null) {
			System.err.println("Unable to access to " + fileName);
			return;
		}
		String line;
		String str = "";
		try {
			try (BufferedReader txt = new BufferedReader(new InputStreamReader(stream))) {
				line = txt.readLine();
				while (line != null) {
					if (!line.isEmpty() && line.startsWith("#")) {
						if (line.startsWith("#Date")) {
							line = txt.readLine();
							continue;
						}
						str += line.replaceFirst("#", "").trim() + "\n";
					} else {
						break;
					}
					line = txt.readLine();
				}
			}
			txComment.setText(str);
			txComment.setEditable(true);
			txComment.setCaretPosition(0);
		} catch (IOException ex) {
			System.err.println("Unable to read comment, perhaps it is missing.");
		}
	}

	private void writeComment(Writer out) {
		String str = txComment.getText();
		if (str != null) {
			String s[] = str.split("\n");
			for (String x : s) {
				String bytes = "#" + x + "\n";
				try {
					out.write(bytes);
				} catch (IOException ex) {
					ex.printStackTrace(System.err);
				}
			}
		}
	}

	private int onExit() {
		//System.out.println("onExit() modified=" + (modified ? "true" : "false"));
		if (modified) {
			if (JOptionPane.showConfirmDialog(null,
					"Modified data not save. Are you sure you want to exit?",
					"Confirm",
					JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
				dispose();
				return (JDialog.DISPOSE_ON_CLOSE);
			} else {
				//dispose();
				return (JDialog.DO_NOTHING_ON_CLOSE);
			}
		} else {
			dispose();
		}
		exit(0);
		return (JDialog.DO_NOTHING_ON_CLOSE);
	}

	private void setLanguageHeader() {
		table.getTableHeader().getColumnModel().getColumn(2).setHeaderValue(curLanguage);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		//System.out.println("actionPerformed(e=" + e.toString() + ")");
		if (e.getActionCommand().equals("Copy")) {
			int row = table.getSelectedRow();
			if (row == -1) {
				return;
			}
			if (table.getValueAt(row, 1) != null) {
				String str = ((String) table.getValueAt(row, 1));
				TextClipboard.setClipboardContents("i18n:"+str);
			}
		}
		if (e.getActionCommand().equals("Past")) {
			int row = table.getSelectedRow();
			if (row == -1) {
				return;
			}
			if (table.getValueAt(row, 1) != null) {
				String str=TextClipboard.getClipboardContents();
				if (!str.startsWith("i18n:")) return;
				str.replace("i18n:", "");
				table.setValueAt(str, row, 2);
				text.setEditable(true);
				text.setText(str);
				text.setCaretPosition(0);
			}
		}
	}

}
